#!/usr/bin/perl
# Copyright 2004 Erik Johnson
#
# This code is UGLY.  That is what trying to get something done in 48 hours will cause though.
#


use SDL::App;
use SDL::Rect;
use SDL::Color;
use SDL::Event;
use SDL::Surface;

use diagnostics;
use strict;
use warnings;

sub MAX_X { 800; }
sub MAX_Y { 580; }

#colors
my $white = SDL::Color->new(-r => 0xff, -g => 0xff, -b => 0xff);
my $yellow = SDL::Color->new(-r => 0xBB, -g => 0xBB, -b => 0x00);
my $grey = SDL::Color->new(-r => 0x44, -g => 0x44, -b => 0x44);

# Ugly hacky image setup.
my $app = SDL::App->new(-height => 600,-width  => 800,-depth  
                        => 16,-title  => 'Eaters Of Coins');
my $bg_buffer = SDL::Surface->new(-height => 600,-width  => 800, -name=>"images/black.png");

my $p1wins_surf = SDL::Surface->new(-name=>"images/1wins.png");
$p1wins_surf->set_color_key(SDL_SRCCOLORKEY, $white);
my $p1wins_src = SDL::Rect->new(-height => $p1wins_surf->height(),-width  => $p1wins_surf->width(), -x => 0, -y => 0);
my $p1wins_target = SDL::Rect->new(-height => $p1wins_surf->height(),-width  => $p1wins_surf->width(), -x => &MAX_X / 2 - $p1wins_surf->width() / 2 + 0.5, -y => 10);

my $p2wins_surf = SDL::Surface->new(-name=>"images/2wins.png");
$p2wins_surf->set_color_key(SDL_SRCCOLORKEY, $white);
my $p2wins_src = SDL::Rect->new(-height => $p2wins_surf->height(),-width  => $p2wins_surf->width(), -x => 0, -y => 0);
my $p2wins_target = SDL::Rect->new(-height => $p2wins_surf->height(),-width  => $p2wins_surf->width(), -x => &MAX_X / 2 - $p2wins_surf->width() / 2 + 0.5, -y => 10);

my $draw_surf = SDL::Surface->new(-name=>"images/draw.png");
$draw_surf->set_color_key(SDL_SRCCOLORKEY, $white);
my $draw_src = SDL::Rect->new(-height => $draw_surf->height(),-width  => $draw_surf->width(), -x => 0, -y => 0);
my $draw_target = SDL::Rect->new(-height => $draw_surf->height(),-width  => $draw_surf->width(), -x => &MAX_X / 2 - $draw_surf->width() / 2 + 0.5, -y => 10);

my $title_surf = SDL::Surface->new(-name=>"images/title.png");
$title_surf->set_color_key(SDL_SRCCOLORKEY, $white);
my $title_src = SDL::Rect->new(-height => $title_surf->height(),-width  => $title_surf->width(), -x => 0, -y => 0);
my $title_target = SDL::Rect->new(-height => $title_surf->height(),-width  => $title_surf->width(), -x => &MAX_X / 2 - $title_surf->width() / 2 + 0.5, -y => 20);

my $menu_surf = SDL::Surface->new(-name=>"images/menu.png");
$menu_surf->set_color_key(SDL_SRCCOLORKEY, $white);
my $menu_src = SDL::Rect->new(-height => $menu_surf->height(),-width  => $menu_surf->width(), -x => 0, -y => 0);
my $menu_target = SDL::Rect->new(-height => $menu_surf->height(),-width  => $menu_surf->width(), -x => &MAX_X / 2 - $menu_surf->width() / 2 + 0.5, -y => 150);

my $hud_rect = SDL::Rect->new(-height => 20, -width  => &MAX_X, -x => 0, -y => &MAX_Y + 1);
$app->fill($hud_rect, $grey);

my $p1coinbar = SDL::Rect->new(-height => 10, -width  => 1, -x => &MAX_X * 3/4 + 20, -y => &MAX_Y + 5);
my $p2coinbar = SDL::Rect->new(-height => 10, -width  => 1, -x => &MAX_X * 1/4 + 20, -y => &MAX_Y + 5);
my $icon1 = SDL::Rect->new(-height => 15, -width  => 15, -x => &MAX_X * 3/4 , -y => &MAX_Y + 2);
my $icon2 = SDL::Rect->new(-height => 15, -width  => 15, -x => &MAX_X * 1/4 , -y => &MAX_Y + 2);


my $event = SDL::Event->new;

my ($bg_rect, $bg_col) = &getbg();

my @keymaps; 
push @keymaps, { &SDLK_UP => 'up', &SDLK_DOWN => 'down', &SDLK_LEFT => 'left', &SDLK_RIGHT => 'right' };
push @keymaps, { &SDLK_w => 'up', &SDLK_s => 'down', &SDLK_a => 'left', &SDLK_d => 'right' }; 

my %syskeys = (&SDLK_ESCAPE => 'quit',&SDLK_o => 'enup', &SDLK_i => 'endown', &SDLK_F1 => '1up', &SDLK_F2 => '2up',&SDLK_F3 => '3up');

my $iq = 0.5;
my $done = 0;
my $paused = 0;
my $oldt = 0;
my $newt = 0;
my $deltat = 0;
my $totalt = 0;
my $player_count = 0;
my $printed = 0;
my $menu = 1;
my $title = 1;

my $player2ai = 0;

my $origin16 = SDL::Rect->new(-height => 16,-width  => 16, -x => 0, -y => 0);

my @coins;# = &getcoinarray(41);
my %player1 = &getplayer(1);
my %old_player1 = &getplayer(1);
my %player2 = &getplayer(2);
my %old_player2 = &getplayer(2);

$player1{'energy'} = 2.4;
$player2{'energy'} = 2.4;

#$title_surf->blit($title_src, $app, $title_target);
#$title_surf->blit($title_src, $bg_buffer, $title_target);
#$menu_surf->blit($menu_src, $app, $menu_target);
#$menu_surf->blit($menu_src, $bg_buffer, $menu_target);

$app->fill($icon1, $player1{col});
$app->fill($icon2, $player2{col});
$app->update($hud_rect);

sub start_game
{
  my($players, $easy) = @_;

  if($players == 2)
  {
    $player2ai = 0;
  }
  else
  {
    $player2ai = 1;
  }

  if($easy)
  {
    $iq = 0.38;
  }
  else
  {
    $iq = 0.5;
  }

  $menu = 0;
  $title = 0;
  @coins = &getcoinarray(41);
  %player1 = &getplayer(1);
  %old_player1 = &getplayer(1);
  %player2 = &getplayer(2);
  %old_player2 = &getplayer(2);

  $bg_buffer->fill($bg_rect, $bg_col);
  $app->fill($bg_rect, $bg_col);
  $app->fill($hud_rect, $grey);
  $app->fill($icon1, $player1{col});
  $app->fill($icon2, $player2{col});
  $app->update($hud_rect);
}

while(!$done)
{
  #clock update
  $newt = $app->ticks;
  $deltat = ($newt - $oldt) * 0.1;
  $oldt = $newt;
  if(!$paused)
  {
    $totalt+=$deltat*10;
  }

  #input handler
  $event->pump;
  if ($event->poll != 0)
  {
    if ($event->type eq SDL_KEYDOWN)
    { 
      my $keypressed = $event->key_sym;
      if(&member($keypressed, keys(%syskeys)))
      {
        if($syskeys{$keypressed} eq 'quit')
        {
          $done = 1;
        }
	#elsif($syskeys{$keypressed} eq 'enup')
	#{
	#  $player1{'energy'} += .2;
	#  print $player1{'energy'}, "\n";
	#}
	elsif($syskeys{$keypressed} eq '1up')
	{
	  &start_game(1,1);
	}
	elsif($syskeys{$keypressed} eq '2up')
	{
	  &start_game(2,0);
	}
	elsif($syskeys{$keypressed} eq '3up')
	{
	  &start_game(1,0);
	}
	#elsif($syskeys{$keypressed} eq 'endown' && $player1{'energy'} >= 0.2 )
	#{
	#  $player1{'energy'} -= .2;
	#  print $player1{'energy'}, "\n";
	#}  
      }  
      if(&member($keypressed, keys(%{$keymaps[0]})))
      {
        $player1{'keydown'}->{$keymaps[0]->{$keypressed}} = 1;
      }
      if(!$player2ai)
      {
        if(&member($keypressed, keys(%{$keymaps[1]})))
        {
          $player2{'keydown'}->{$keymaps[1]->{$keypressed}} = 1;
        }
      }
    }
    elsif ($event->type eq SDL_KEYUP)
    {
      my $keypressed = $event->key_sym;
      if(&member($keypressed, keys(%{$keymaps[0]})))
      {
        $player1{'keydown'}->{$keymaps[0]->{$keypressed}} = 0;
      }
      if(!$player2ai)
      {
        if(&member($keypressed, keys(%{$keymaps[1]})))
        {
          $player2{'keydown'}->{$keymaps[1]->{$keypressed}} = 0;
        }
      }
    }
  }

  #player movement
  &updatepos(\%player1, $player1{'keydown'});
  if(!$player2ai)
  {
    &updatepos(\%player2, $player2{'keydown'});
  }
  else
  {
    &ai_move(\%player2, \@coins);
  }
  &updateplayer(\%player1);
  &updateplayer(\%player2);

  $player1{'trail_shape'}->x($player1{shape}->x()+7);
  $player1{'trail_shape'}->y($player1{shape}->y()+7);
  $player2{'trail_shape'}->x($player2{shape}->x()+7);
  $player2{'trail_shape'}->y($player2{shape}->y()+7);
 
  #update display
  

  $bg_buffer->fill($player1{'trail_shape'}, $player1{'trail_color'});
  $bg_buffer->fill($player2{'trail_shape'}, $player2{'trail_color'});
  $bg_buffer->blit($old_player1{shape}, $app, $old_player1{shape});
  $bg_buffer->blit($old_player2{shape}, $app, $old_player2{shape});
  drawcoins(@coins);

  &collideplayers(\%player1, \%player2);

  $app->fill($player1{shape}, $player1{col});
  $app->fill($player2{shape}, $player2{col});

  my $collision = collidecoins(\%player1, @coins);
  if($collision)
  {
    $bg_buffer->blit($coins[$collision-1]->{'shape'}, $app, $coins[$collision-1]->{'shape'});
    splice(@coins, $collision-1, 1);
    $p1coinbar->width($player1{'coins'} * 2 + 1);
    $app->fill($p1coinbar, $yellow);
    $app->update($hud_rect);
  }
  $collision = collidecoins(\%player2, @coins);
  if($collision)
  {
    $bg_buffer->blit($coins[$collision-1]->{'shape'}, $app, $coins[$collision-1]->{'shape'});
    splice(@coins, $collision-1, 1);
    $p2coinbar->width($player2{'coins'} * 2 + 1);
    $app->fill($p2coinbar, $yellow);
    $app->update($hud_rect);
  }

  $app->fill($player1{shape}, $player1{col});
  $app->fill($player2{shape}, $player2{col});


  if(!$title)
  {
    if(!@coins)
    {
      my $winner = getwinner(\%player1, \%player2);

      $menu = 1;
  
      if($winner == 1)
      {
        $p1wins_surf->blit($p1wins_src, $app, $p1wins_target);
      }
      elsif($winner == 2)
      {
        $p2wins_surf->blit($p2wins_src, $app, $p2wins_target);
      }
      elsif($winner == 0)
      {
        $draw_surf->blit($draw_src, $app, $draw_target);
      }

    }
  }

  if($menu)
  {
    $menu_surf->blit($menu_src, $app, $menu_target);
  }

  if($title)
  {
    $title_surf->blit($title_src, $app, $title_target);
  }

  $app->update( $bg_rect );


  $old_player1{'shape'}->x($player1{'shape'}->x());
  $old_player1{'shape'}->y($player1{'shape'}->y());
  $old_player2{'shape'}->x($player2{'shape'}->x());
  $old_player2{'shape'}->y($player2{'shape'}->y());

}

#print "Coins:\nPlayer1: ",$player1{'coins'},"\tPlayer2: ",$player2{'coins'},"\n";
#print "Energy:\nPlayer1: ",$player1{'energy'},"\tPlayer2: ",$player2{'energy'},"\n";

sub getwinner
{
  my ($player1, $player2) = @_;

  if($player1->{'coins'} == $player2->{'coins'})
  {
    return 0;
  }
  elsif($player1->{'coins'} > $player2->{'coins'})
  {
    return 1;
  }
  else
  {
    return 2;
  }
}
    

sub collideplayers
{
  my @players = @_;

  while(@players)
  {
    my $checker = pop @players;

    foreach (@players)
    {
      &doplayerscollide($checker, $_);
    }
  }
}

sub doplayerscollide
{
  my ($p1, $p2) = @_;

  my $xdiff = $p1->{'shape'}->x() - $p2->{'shape'}->x();

  if(abs($xdiff) < 15)
  {
    my $ydiff =  $p1->{'shape'}->y() - $p2->{'shape'}->y();

    if(abs($ydiff) < 15)
    {
      if(abs($xdiff) > abs($ydiff))
      {
	my $tmpx = $p1->{'x'};
	$p1->{'x'} = $p2->{'x'};
	$p2->{'x'} = $tmpx;
        &moveplayer($p1, int ($xdiff/2), 0);
        &moveplayer($p2, (int ($xdiff/2) + 1)*-1, 0);
      }
      else
      {
	my $tmpy = $p1->{'y'};
	$p1->{'y'} = $p2->{'y'};
	$p2->{'y'} = $tmpy;
        &moveplayer($p1, 0, int ($ydiff/2));
        &moveplayer($p2, 0, (int ($ydiff/2) + 1)*-1);
      }

      my $total_energy = $p1->{'energy'} + $p2->{'energy'};
      $p1->{'energy'} = $total_energy / 2;
      $p2->{'energy'} = $total_energy / 2;;
    }
  }
}

sub ai_move
{
  my ($player, $coins) = @_;

  if(rand() < $iq)
  {
    if(@$coins)
    {
      my ($closeX, $closeY) = &closestcoin($player, $coins);
      my ($x, $y) = get_center($player->{shape});

      if($closeX < $x) { $player->{x} -= .2 * $deltat; }
      elsif($closeX > $x) { $player->{x} += .2 * $deltat; }
      if($closeY < $y) { $player->{y} -= .2 * $deltat; }
      elsif($closeY > $y) { $player->{y} += .2 * $deltat; }
    }
  }
}

sub closestcoin
{
  my ($player, $coins) = @_;

  my $dist = 100000;
  my $tmpdist;
  my $nearest = 0;
  my $i = 0;

  foreach my $coin (@$coins)
  {
    my $tmpdist = &get_dist($coin->{shape}, $player->{shape});

    if($tmpdist < $dist)
    {
      $dist = $tmpdist;
      $nearest = $i;
    }
    $i++;
  }

  return (&get_center($coins->[$nearest]->{shape}));
}
  
sub collidecoins
{
  my $player = shift;
  my $i = 0;

  foreach my $coin (@_)
  {
    $i++;
    my $dist = &get_dist($coin->{shape}, $player->{shape});

    if($dist < 8)
    {
      $player->{'coins'}++;
      $player->{'energy'} += 0.08;
      return $i;
    }
  }

  return 0;
}
    

sub get_dist
{
  my ($rect1, $rect2) = @_;

  my($x1, $y1) = get_center($rect1);
  my($x2, $y2) = get_center($rect2);

  return ( sqrt( ($x1 - $x2)**2 + ($y1 - $y2)**2 ) );
}

sub get_center
{
  my $rect = pop;

  return ( (int ($rect->x() + $rect->width()/2 + 0.5)),
           (int ($rect->y() + $rect->height()/2 + 0.5)) )
}

sub drawcoins
{
  foreach my $coin (@_)
  {
    $coin->{'surface'}->blit($origin16, $app, $coin->{'shape'});
  }
}

sub getcoinarray
{
  my $coin_count = pop;

  my @coins;

  for ( 0 .. $coin_count )
  {
    my %coin = &getcoin;
    push @coins, \%coin;
  }

  return @coins;
}

sub updatepos
{
  my ($player_ref, $keydown_ref) = @_;

  if($keydown_ref->{'up'}) { $player_ref->{y} -= .2 * $deltat; }
  if($keydown_ref->{'down'}) { $player_ref->{y} += .2 * $deltat; }
  if($keydown_ref->{'left'}) { $player_ref->{x} -= .2 * $deltat; }
  if($keydown_ref->{'right'}) { $player_ref->{x} += .2 * $deltat; }

  
}

sub updateplayer
{
  my $player_ref = pop;

  # Random force
  my $randx = (rand(2) -1) * $deltat * .5 * $player_ref->{'energy'};
  my $randy = (rand(2) -1) * $deltat * .5 * $player_ref->{'energy'};
  #print "x $randx\ty $randy\trx $rx\txt $xt\t",rand(),"\n";

  #print "x $player_ref->{x}   y  $player_ref->{y}\n";
  $player_ref->{x}+= $randx;
  $player_ref->{y}+= $randy;

  # Friction
  my $fric = .1 * $deltat;
  
  if($player_ref->{x} > 0) {$player_ref->{x} = $player_ref->{x} - $fric;}
  if($player_ref->{x} < 0) {$player_ref->{x} = $player_ref->{x} + $fric;}
  if($player_ref->{y} > 0) {$player_ref->{y} = $player_ref->{y} - $fric;}
  if($player_ref->{y} < 0) {$player_ref->{y} = $player_ref->{y} + $fric;}

  &moveplayer($player_ref, $player_ref->{x}, $player_ref->{y});
  # add .5 because converting to int truncates the change in position.
  #my $newx = int ($player_ref->{shape}->x() + $player_ref->{x} + 0.5);
  #my $newy = int ($player_ref->{shape}->y() + $player_ref->{y} + 0.5);

  # Walls around the map.
  #if($newx < 0) { $newx = 0; $player_ref->{x} *= -1; }
  #if($newx > (&MAX_X - 20)) { $newx = (&MAX_X - 20); $player_ref->{x} *= -1; }
  #if($newy < 0) { $newy = 0; $player_ref->{y} *= -1;}
  #if($newy > (&MAX_Y - 20)) { $newy = (&MAX_Y - 20); $player_ref->{y} *= -1;}
  #print "$newx $newy ", &MAX_X , " ", &MAX_Y, "\n";
  #$player_ref->{shape}->x($newx);
  #$player_ref->{shape}->y($newy);

  #print $player_ref->{shape}->x(), " ", $player_ref->{shape}->y(), " ", $player_ref->{x}, " ", $player_ref->{y},"\n";
}

sub moveplayer
{
  my ($player, $dx, $dy) = @_;
  
  # add .5 because converting to int truncates the change in position.
  my $newx = int ($player->{shape}->x() + $dx + 0.5);
  my $newy = int ($player->{shape}->y() + $dy + 0.5);

  # Walls around the map.
  if($newx < 0) { $newx = 0; $player->{x} *= -1; }
  if($newx > (&MAX_X - 20)) { $newx = (&MAX_X - 20); $player->{x} *= -1; }
  if($newy < 0) { $newy = 0; $player->{y} *= -1;}
  if($newy > (&MAX_Y - 20)) { $newy = (&MAX_Y - 20); $player->{y} *= -1;}
  #print "$newx $newy ", &MAX_X , " ", &MAX_Y, "\n";
  #$player_ref->{shape}->x($player_ref->{shape}->x() + $player_ref->{x} + 0.5);
  #$player_ref->{shape}->y($player_ref->{shape}->y() + $player_ref->{y} + 0.5);
  $player->{shape}->x($newx);
  $player->{shape}->y($newy);
}


sub getbg
{
  my $bg = SDL::Rect->new( 
        -height => MAX_Y,
        -width  => MAX_X,
        -x      => 0,
        -y      => 0
  );
  my $bg_color = SDL::Color->new(-r => 0x00, -g => 0x00, -b => 0x00);

  return($bg, $bg_color);
}

sub gettrail
{
  my $rect = SDL::Rect->new( 
        -height => 1,
        -width  => 1,
        -x      => 0,
        -y      => 0
  );
  my $color = SDL::Color->new(-r => 0x00, -g => 0x55, -b => 0x55);

  return($rect, $color);
}


sub getplayer
{
  my $color = pop;

  my $startx = get_rand_x(16);
  my $starty = get_rand_y(16);
  my ($col, $trail_col);

  if($color == 1)
  {
    $col = SDL::Color->new(-r => 0x00, -g => 0x00, -b => 0xff);
    $trail_col = SDL::Color->new(-r => 0x00, -g => 0x55, -b => 0x55);
  }
  else
  {
    $col = SDL::Color->new(-r => 0xff, -g => 0x00, -b => 0x00);
    $trail_col = SDL::Color->new(-r => 0x55, -g => 0x55, -b => 0x00);
  }
    
  $player_count++;

  my %keydown = ( up => 0, down => 0, left => 0, right => 0 );

  my %player = (
        energy => 0,
        x => 0,
        y => 0,
	coins => 0,
	keydown => \%keydown,
	col => $col,
        shape => SDL::Rect->new( -height => 15, -width  => 15, -x => $startx, -y => $starty),
	trail_shape => SDL::Rect->new( -height => 1, -width  => 1, -x => $startx + 7, -y => $starty + 7),
	trail_color => $trail_col
     );

  return  %player;
}


sub getcoin
{
  my %coin = (
    surface => SDL::Surface->new(-name=>'images/coin.png'),
    shape => SDL::Rect->new(-x => get_rand_x(16), -y => get_rand_y(16), -width=>16, -height=>16)
    );
  $coin{'surface'}->set_color_key(SDL_SRCCOLORKEY, $white);
  return %coin;
}


sub get_rand_x
{
  my $max_x = MAX_X;
  if($_[0])
  {
    $max_x -= $_[0];
  }
  return (int (rand($max_x)));
}


sub get_rand_y
{
  my $max_y = MAX_Y;
  if($_[0])
  {
    $max_y -= $_[0];
  }
  return (int (rand($max_y)));
}


sub member
{
  my $key = shift;

  #print "$key  ::  ", join(";;", @_),"\n";
  foreach(@_)
  {
    if($key eq $_)
    {
      return 1;
    }
  }
  0;
}
